$path = $(Join-Path $env:ProgramData CustomScripts)
if (!(Test-Path $path))
{
New-Item -Path $path -ItemType Directory -Force -Confirm:$false
}

try {
    $source = 'https://call4cloud.nl/wp-content/uploads/2022/04/setacl.zip'
$destination = 'c:\programdata\customscripts\setacl.zip'
Invoke-WebRequest -Uri $source -OutFile $destination  | out-null
Expand-Archive c:\programdata\customscripts\setacl.zip -DestinationPath c:\programdata\customscripts -force | out-null
copy-item "C:\ProgramData\CustomScripts\SetACL (executable version)\64 bit\SetACL.exe" C:\ProgramData\CustomScripts\setacl.exe
    
}
Catch {
    Write-host "Directory does not exist"
}

try {
    C:\ProgramData\CustomScripts\SetACL.exe -on "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Provisioning\SyncML\RebootRequiredURIs" -ot reg -actn setowner -ownr "n:Administrators"
C:\ProgramData\CustomScripts\SetACL.exe -on "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Provisioning\SyncML\RebootRequiredURIs" -ot reg -actn ace -ace "n:administrators;p:full"
    
}
Catch {
    Write-host "Directory does not exist"
}

$Path = "hklm:\SOFTWARE\Microsoft\Provisioning\SyncML\RebootRequiredURIs"
$value = "./Device/Vendor/MSFT/Policy/Config/Update/ManagePreviewBuilds"

If (Get-ItemProperty -Path $path -Name $value  -ErrorAction SilentlyContinue) {
    remove-ItemProperty -Path $path -Name $value  -ErrorAction SilentlyContinue
    C:\ProgramData\CustomScripts\SetACL.exe -on "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Provisioning\SyncML\RebootRequiredURIs" -ot reg -actn setowner -ownr "n:nt service\trustedinstaller" -rec Yes
}Else
{
    Write-Output 'Value DOES NOT exist'
  C:\ProgramData\CustomScripts\SetACL.exe -on "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Provisioning\SyncML\RebootRequiredURIs" -ot reg -actn setowner -ownr "n:nt service\trustedinstaller" -rec Yes
}

